import java.io.*;
import java.net.*;


class upsilonprog{

  /*
    Upsilonprog 1.0
    An Eyewitness
    aneyewitness@geocities.com
    Autumn 98
    Get IP and ICQ port from UIN
  */

  String uinString[];
  String localUin;
  String passwd;
  DatagramSocket socket;
  InetAddress ICQServer;

  public static void main(String args[]){

    String info;

    System.out.println("Upsilonprog 1.0 \nBy An Eyewitness\nAutumn 98\n");
    if(args.length<3){
      System.err.println("Usage: upsilonprog <localUIN> <localUin password> <UIN> [UIN] ...");
      System.exit(1);
    }
    
    try{
      String uin[] = new String[args.length-2];
      for(int i=0;i<args.length-2;i++)
	uin[i] = args[i+2];
      
      upsilonprog upsilon = new upsilonprog(uin, args[0], args[1]);
      info = upsilon.getIP_Port();
      if(info.length() == 0)
	System.out.println("All UIN are offline or invisible");
      else
	System.out.println(info);

    }
    catch(IOException ex){
      ex.printStackTrace();
    }
  }

  public upsilonprog(String uinString[], String localUin, String passwd) throws IOException{

    this.uinString = uinString;
    this.localUin = localUin;
    this.passwd = passwd;

    ICQServer = InetAddress.getByName("icq.mirabilis.com");

  }

  public String getIP_Port() throws IOException{

    login();
    sendContactList();
    return readReply();

  }

  void login() throws IOException{

    byte buff[] = new byte[128];
    byte abuff[] = new byte[128];
    byte acks[] = new byte[10];
    String port; // socket port number in Hex
    int portlen; // string port length
    byte passwdBytes[];
    DatagramPacket loginPacket, answer, ack;
    boolean ok = false;

    // filling buff

    buff[0] = (byte) 0x02; // version
    buff[1] = (byte) 0x00;
    buff[2] = (byte) 0xE8; // cmd
    buff[3] = (byte) 0x03;
    buff[4] = (byte) 0x00; // seq number
    buff[5] = (byte) 0x00;

    byte localUinBytes[] = UIN.toBytes(localUin);
    for(int i=0;i<4;i++)
      buff[6+i] = localUinBytes[i];
    

    socket = new DatagramSocket();
    socket.setSoTimeout(15000);
    port = Integer.toHexString(socket.getLocalPort());
    portlen = port.length();
    buff[10] = (byte) Integer.parseInt(port.substring(portlen-2), 16);
    if(portlen==3)
      buff[11] = (byte) Integer.parseInt(port.substring(portlen-3,portlen-2), 16);
    else
      buff[11] = (byte) Integer.parseInt(port.substring(portlen-4,portlen-2), 16);

    buff[14] = (byte) (passwd.length() + 1);
    passwdBytes = passwd.getBytes();
    for(int i=0;i<passwd.length();i++)
      buff[16 + i] = passwdBytes[i];
    buff[16 + passwd.length()] = (byte) 0x00;

    ICQServer = InetAddress.getByName("icq.mirabilis.com");

    loginPacket = new DatagramPacket(buff, passwd.length() + 17, ICQServer, 4000);
    socket.send(loginPacket);

    while(!ok){
      try{
	answer = new DatagramPacket(abuff, 128);
	socket.receive(answer);
	if(abuff[2] == (byte) 0x0A && abuff[3] == (byte) 0x00){
	  // ACK
	}
	else{
	  if(abuff[2] == (byte) 0x64 && abuff[3] == (byte) 0x00){
	    System.err.println("Can't login, wrong passwd");
	    System.exit(1);
	  }
	  else if(abuff[2] == (byte) 0x5A && abuff[3] == (byte) 0x00){
	    acks[0] = (byte) 0x02;
	    acks[2] = (byte) 0x0A;
	    acks[4] = abuff[4];
	    acks[5] = abuff[5];
	    for(int i=6;i<10;i++)
	      acks[i] = buff[i]; // copy localUin
	    ack = new DatagramPacket(acks, 10, ICQServer, 4000);
	    socket.send(ack);	    
	    ok = true;
	  }
	  else if(abuff[2] == (byte) 0xFA && abuff[3] == (byte) 0x00){
	    System.err.println("UIN is online, can't login.");
	    System.exit(1);
	  }   
	  else{
	    System.err.println("Unknown reply from ICQ server");
	    System.exit(1);
	  }
	}
      }
      catch(InterruptedIOException ex){
	System.out.println("Timeout during login. Resending packet");
	socket.send(loginPacket);
      }
    }   
  }


  void sendContactList() throws IOException{
    
    byte buff[] = new byte[128];
    DatagramPacket listPacket;

    buff[0] = (byte) 0x02; // version
    buff[1] = (byte) 0x00;
    buff[2] = (byte) 0x06; // cmd
    buff[3] = (byte) 0x04;
    buff[4] = (byte) 0x00; // seq number
    buff[5] = (byte) 0x00;

    byte localUinBytes[] = UIN.toBytes(localUin);
    for(int i=0;i<4;i++)
      buff[6+i] = localUinBytes[i];

    buff[10] = (byte) uinString.length; // Contacts number
    // buff[11] = (byte) 0x00;

    for(int i=0;i<uinString.length;i++){
      byte uinBytes[] = UIN.toBytes(uinString[i]);
      for(int j=0;j<4;j++)
	buff[11+i*4+j] = uinBytes[j];
    }

    listPacket = new DatagramPacket(buff, 11+4*uinString.length, ICQServer, 4000);
    socket.send(listPacket);

  }

  String readReply() throws IOException{

    byte abuff[] = new byte[128];
    byte acks[] = new byte[10];
    byte localUinBytes[];
    DatagramPacket answer = new DatagramPacket(abuff, 128);
    DatagramPacket ack;
    boolean ok = false;
    String info = new String("");

    acks[0] = (byte) 0x02;
    acks[2] = (byte) 0x0A;
    localUinBytes = UIN.toBytes(localUin);
    for(int i=0;i<4;i++)
      acks[i+6] = localUinBytes[i]; // copy localUin
    do{
      try{
	answer = new DatagramPacket(abuff, 128);
	socket.receive(answer);
	if(abuff[2] == (byte) 0x0A && abuff[3] == (byte) 0x00){
	  // ACK
	}
	else{
	  
	  String port = new String("");
	  String ipString = new String("");
	  
	  acks[4] = abuff[4];
	  acks[5] = abuff[5];
	  
	  ack = new DatagramPacket(acks, 10, ICQServer, 4000);
	  socket.send(ack);
	  
	  if(abuff[2] == (byte) 0x6E && abuff[3] == (byte) 0x00){
	    byte tmpbuff[] = new byte[4];
	    for(int i=0;i<4;i++)
	      tmpbuff[i] = abuff[i+6];
	    info = info.concat(UIN.toString(tmpbuff) + " ");
	  
	    for(int i=0;i<4;i++)
	      tmpbuff[i] = abuff[i+10];
	    
	    for(int i=0;i<4;i++){
	      Byte ipByte = new Byte(tmpbuff[i]);
	      String temp = Integer.toHexString(ipByte.intValue());
	      // to make sure we get a 2 number long number, not just 5 or fffffa
	    if(temp.length()==1)
	      temp = new String("0" + temp);
	    else if(temp.length()>2)
	      temp = temp.substring(temp.length()-2);
	    temp = Integer.toString(Integer.parseInt(temp, 16));
	    ipString = ipString.concat(temp);	    
	    if(i<3)
	      ipString = ipString.concat(".");
	    }
	    info = info.concat(ipString + ":");
	    
	    
	    for(int i=1;i>-1;i--){
	      Byte portByte = new Byte(abuff[14+i]);
	      String temp =  Integer.toHexString(portByte.intValue());
	      if(temp.length()==1)
		temp = new String("0" + temp);
	      else if(temp.length()>2)
		temp = temp.substring(temp.length()-2);
	      port = port.concat(temp);
	  }
	    port = Integer.toString(Integer.parseInt(port, 16));
	    info = info.concat(port + "\r\n");
	  }
	}
      }
      catch(InterruptedIOException ex){
	System.out.println("Timeout on socket. Resending packet");
	sendContactList();
	info = new String("");
      }
    }while(abuff[2] != (byte) 0x1C && abuff[3] != (byte) 0x02);
    
    return info;
  }
}

class UIN{
  /*
    convert UIN string to byte array and byte array to UIN
  */

  public static byte[] toBytes(String uinString){

    byte uinBytes[] = new byte[4];

    String uinHex = Integer.toHexString(Integer.parseInt(uinString));

    int uinLength = uinHex.length();

    uinBytes[0] = (byte) Integer.parseInt(uinHex.substring(uinLength-2), 16);
    uinBytes[1] = (byte) Integer.parseInt(uinHex.substring(uinLength-4,uinLength-2), 16);
    if(uinLength>4){
      if(uinLength==5)
	uinBytes[2] = (byte) Integer.parseInt(uinHex.substring(uinLength-5,uinLength-4), 16);
      else
	uinBytes[2] = (byte) Integer.parseInt(uinHex.substring(uinLength-6,uinLength-4), 16);
    }
    if(uinLength>6){
      if(uinLength==7)	 
	uinBytes[3] = (byte) Integer.parseInt(uinHex.substring(uinLength-7,uinLength-6), 16);
      else
	uinBytes[3] = (byte) Integer.parseInt(uinHex.substring(uinLength-8,uinLength-6), 16);
    }
    
    return uinBytes;
  }


  

  public static String toString(byte uinBytes[]){
    
    String uinHex = new String("");
    for(int i=3;i>-1;i--){
      Byte uinByte = new Byte(uinBytes[i]);
      String temp = Integer.toHexString(uinByte.intValue());
      // to make sure we get a 2 number long number, not just 5 or fffffa
      if(temp.length()==1)
	temp = new String("0" + temp);
      else if(temp.length()>2)
	temp = temp.substring(temp.length()-2);
      uinHex = uinHex.concat(temp);
    }
    return Integer.toString(Integer.parseInt(uinHex, 16));
  }
}






